#	Model_Scramble.rb
#
#	Created by •BTM on 09/06/09.
#
#	THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED
#	WARRANTIES.
#
#	Version:	1.0
#	Use:		Rotates groups and Components slightly, explodes them, purges unused components,
#				then takes all faces and reverses random ones, painting them as they were.
#
#	UPDATE June 11, 2009:	It is now able to explode all curves, and moves random points or all points by random vectors,
#							based on a value input by the user, which dictates maximum distance in all directions.
#
#
#	Description:	It's meant as a way to scramble a model, to make it harder to edit.
#
require 'Sketchup.rb'


class Model_Scramble

	def activate
	@model = Sketchup.active_model
	@entities = @model.entities
	@definitions = @model.definitions
	
	@rev = []
	@grp = []
	@ins = []
	@vecs = []
#------------------------------------------------------------------------------------
	prompts = ["Rotate_Groups?", "Explode_Groups?", "Reverse_Faces?","Scatter_Points?"]
	defaults = ["yes", "yes", "yes","some"]
	list = ["yes|no", "yes|no", "yes|no","none|some|all"]
	results = UI.inputbox (prompts, defaults, list, "Scramble Model")
	
		if results[0]== "yes"
		@repr= 1
		elsif results[0]== "no"
		@repr= 0
		end
		
		if results[1]== "yes"
		@repe= 1
		elsif results[1]== "no"
		@repe= 0
		end
		
		if results[2]== "yes"
		@rep= 1
		elsif results[2]== "no"
		@rep= 0
		end
	
		if results[3]== "no"
		@repp= 0
		elsif results[3]== "some"
		@reps= 1
		elsif results[3]== "all"
		@reps= 2
		end
#------------------------------------------------------------------------------------
		@entities.each do |g|
			if g.typename== "Group" or g.typename== "ComponentInstance"
				if @repr== 1
				@pnt= Geom::Point3d.new ( 0, 0, 0)
				@vcr= Geom::Vector3d.new ( 1, 1, 1)
				@rte= Geom::Transformation.rotation @pnt, @vcr, 0.002
				g.transformation= g.transformation*@rte
				end
			@grp << g
			end
		end
#------------------------------------------------------------------------------------
		if @repe== 1
		@grp.each do |t|
		t.make_unique
		t.explode
		@definitions.purge_unused
		end
		end
#------------------------------------------------------------------------------------
		if @reps== 2 or @reps== 1
		prompts = ["scatter max."]
		defaults = [ 0.0.to_l]
		list = [""]
		results = UI.inputbox prompts, defaults, list, "Please input desired radius."
		@rad= results[0].to_l
		
			@entities.each do |p|
				if p.typename== "Edge"
				p.explode_curve
#  -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -
					if @reps==1
					r = rand()
						if r >=0.5
						@ins << p.start
						@ins << p.end
						end
#  -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -
					elsif @reps==2
					@ins << p.start
					@ins << p.end
					end
				end
			end
#  -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -
			@ins.each do |r|
			vec= Geom::Vector3d.new [ (rand()-0.5)*@rad, (rand()-0.5)*@rad, (rand()-0.5)*@rad]
			@vecs << vec
			end
#  -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -
		@entities.transform_by_vectors @ins, @vecs
		end
#------------------------------------------------------------------------------------
		if @rep== 1
			@entities.each do |e|
				if e.typename== "Face"
				r = rand()
					if r >=0.5
					@rev << e
					end
				end
			end
		end
#------------------------------------------------------------------------------------
		if @rep== 1
			@rev.each do |f|
			@t= f.material
			f.back_material= @t
			f.reverse!
			end
		end
#------------------------------------------------------------------------------------
	end
end

plugins_menu = UI.menu("Plugins")
item = plugins_menu.add_item("Scramble Model") {
Sketchup.active_model.select_tool Model_Scramble.new
}